﻿init python:
    class contact:
        def __init__(self, number = _("No number"), name = _("Unknown"), img = "phone/img.png", id = ""):
            self.number = number
            self.name = name
            self.img = img
            self.id = id

        def edit(self, name = None, number = None, img = None):
            if name:
                self.name = name
            if number:
                self.number = number
            if img:
                self.img = img

    class conversation:
        def __init__(self, name = _("No name"), img = "phone/img.png", history = []):
            self.name = name
            self.img = img
            self.history = history
            self.index = 0
        def advance(self):
            self.index += 1
    
    class app:
        def __init__(self, account, contacts = [], chats = []):
            self.account = account
            self.contacts = contacts
            self.chats = chats
            
        def add_contact(self, c):
            self.contacts.append(c)
        def add_chat(self, c):
            self.chats.append(c)

        def get_contact(self, id):
            for i in self.contacts:
                if i.id == id:
                    return i
                    break
            else:
                return False


default contact_me = contact(
    "2353463",
    "Me",
    "phone/me.png",
    id = "me",
)
default contact_ed = contact(
    "9546451222",
    "Anita",
    "phone/ed.png",
    id = "ed",
)
default contact_edd = contact(
    "9546451222",
    "Nanyako",
    "phone/edd.png",
    id = "edd",
)
default contact_eddy = contact(
    "9546451222",
    "Eddy",
    "phone/eddy.png",
    id = "eddy",
)

default chat_ed = conversation(
    "My besties",
    history = [
        ["ed", "Hey Edd"],
        ["edd", "Yeah eddy?"],
        ["ed", "Where's eddy?"],
        ["eddy", "I'm here."],
        ["me", "Hi guys."],
        ["me", "Can I say something long to see how it wraps in the frame?"],
    ]

)
default chat_edd = conversation(
    "Anita",
    history = [
        ["me", "Hey nita, are we going out tonight?"],
        ["ed", "Of course"],
        ["me", "Alright then."],
        ["me", "I'll see you at 5:20 the usual place."],
        ["ed", "sure"],
    ]
)
default chat_eddy = conversation(
    "Ted Burns",
    history = [
        ["me", "You up?"],
    ]
)

default chat_app_1 = app(
    contact_me,
    [
        contact_ed,
        contact_edd,
        contact_eddy,
        contact_me,
    ],
    [
        chat_ed,
        chat_edd,
        chat_eddy,
    ]
)
screen chat_app(a = chat_app_1):
    modal True
    frame:
        xysize(600,900) padding(0,0) background "#222"
        vbox:
            yalign 0.0
            frame:
                ysize 180 xfill True background "#064"
                hbox:
                    yalign 0.0 xfill True
                    text _("Wazzaaaaa!") xalign 0.0 size 30
                    hbox:
                        xalign 1.0
                        # text "⬅" size 50
                        # text "⁕" size 50
                        text "≡" size 50
                button:
                    align 0.0,1.0 background "#222" xysize 40,40
                    text "⬅"
                    action Hide("chat_app")
            vbox:
                for i in a.chats:
                    button:
                        xfill True background "#fff" xpadding 40
                        hbox:
                            xalign 0.0
                            add i.img
                            vbox:
                                text i.name color "#000" xalign 0.0
                                if len(i.history):
                                    text "{:.25}...".format(i.history[-1][1]) color "#666"
                        action Show("chat_app_chat", c = i, a = a)

screen chat_app_chat(c , a):
    modal True
    frame:
        xysize(600,900) padding(0,0) background "#222"
        frame:
            ysize 100 xfill True background "#064" yalign 0.0
            button:
                align 0.0,.5 background "#222" xysize 40,40
                text "⬅"
                action Hide("chat_app_chat")
            text c.name

        frame:
            background None yalign 1.0
            vbox:
                xfill True
                for i in c.history:
                    $ sender = a.get_contact(i[0])
                    if sender == a.account:
                        hbox:
                            xalign 1.0 spacing 0
                            frame:
                                background Frame(im.Flip("phone/chat_frame.png", True), 8, 8, 16, 8) padding 8,8,16,8 xmaximum 500
                                vbox:
                                    text a.account.name color "#606" xalign 0.0
                                    text i[1] color "#000"
                            add a.account.img yalign 1.0

                    else:
                        hbox:
                            xalign 0.0 spacing 0
                            add sender.img yalign 1.0
                            frame:
                                background Frame("phone/chat_frame.png", 16, 8, 8, 8) padding 16,8,8,8 xmaximum 500
                                vbox:
                                    text sender.name color "#08f" xalign 0.0
                                    text i[1] color "#000"
                frame:
                    background Frame(im.Flip("phone/chat_frame.png", True), 8, 8, 16, 8) padding 8,8,16,8 xfill True yminimum 60
                    text "Type something..." color "#aaa" xalign 0.0












