﻿init python:
    class phone_contact:
        def __init__(self, id, name = _("Unknown"), number = _("No number"), img = "phone/img.png", sms = [], current = None, times = None):
            self.id = id
            self.name = name
            self.number = number
            self.img = img
            self.sms = sms
            self.typing = ""
            self.current = current
            self.times = times
            self.phase = 0
            self.unread = 0
        def edit(self, name = None, number = None, img = None):
            if name:
                self.name = name
            if number:
                self.number = number
            if img:
                self.img = img
        def add(self, sender, message, times):
            if times is not None:
                self.times = times
            else:
                self.times = [500, len(message)*40, 500]

            self.current = [sender, message]
            self.phase = 0
            # return

        def tick(self, phone):
            if self.current[0] == self.id:
                if self.times is not None:
                    if len(self.times) > 0:
                        if self.times[0] <= 0:
                            self.times.pop(0)
                            if self.phase == 0:
                                self.phase = 1
                            else:
                                self.phase = 0
                        else:
                            self.times[0] -= 100
                        return False
                    else:
                        self.sms.append(self.current)
                        self.current = None
                        self.times = None
                        if phone.active == self:
                            renpy.hide_screen("phone_sms")
                            renpy.show_screen("phone_sms", phone)
                        else:
                            self.unread += 1
                            phone.ring_sms()
                        return True
            else:
                if self.times is not None:
                    if self.phase == 0:
                        if self.times[0] <= 0:
                            self.times.pop(0)
                            if self.phase == 0:
                                self.phase = 2
                            else:
                                self.phase = 0
                        else:
                            self.times[0] -= 100
                        return False
                    elif self.phase == 2:
                        if len(self.current[1]) == len(self.typing):
                            self.phase = 3
                        else:
                            self.typing += self.current[1][len(self.typing)]
        def send(self, phone):
            self.sms.append(self.current)
            self.current = None
            self.times = None
            self.phase = 0
            self.typing = ""
            renpy.hide_screen("phone_sms")
            renpy.show_screen("phone_sms", phone)
            return True


    class phone_class:
        def __init__(self, owner, id, img = None):
            self.owner = owner
            self.id = id
            self.img = img
            self.active = None
            self.open = None
            self.stat = "Closed"
            self.contacts = []
            self.typing = ""
            self.showing = None
            self.wiggle = 0

        def get_unread(self):
            u = 0
            for i in self.contacts:
                u += i.unread
            return u
        def show(self, screen, sender = None):
            self.showing = screen
            if screen == "phone":
                renpy.show_screen("phone", self)
            elif screen == "sms list":
                self.active = None
                renpy.show_screen("phone_sms_list", self)
            elif screen == "sms":
                for i in self.contacts:
                    if i.id == sender:
                        self.active = i
                        i.unread = 0
                renpy.show_screen("phone_sms", self)
            elif screen == "contacts_list":
                renpy.show_screen("phone_contacts_list", self)

        def sms(self, contact, message, sender, times):
            if not sender:
                sender = self.id

            for i in self.contacts:
                if i.id == contact:
                    i.add(sender, message, times)
                    break
            else:
                self.contacts.append(phone_contact(contact, current = [sender, message], times = times))
            renpy.pause(hard=True)
            

        def add(self, id, name = _("Unknown"), number = _("No number"), img = None):
            if id == "new_contact":
                for i in phone_number_list:
                    if i[1] == number:
                        id = i[0]
                        break
                else:
                    id = "c"+number
            for i in self.contacts:
                if i.id == id:
                    i.name = name
                    i.number = number
                    i.img = img
                    break
            else:
                self.contacts.append(phone_contact(id, name, number, img))

        def tick(self):
            if self.wiggle:
                self.wiggle -= 1
            for i in self.contacts:
                if i.current:
                    if i.tick(self):
                        return 1
        def ring_sms(self):
            renpy.play("phone/sms.ogg", "sound")
            self.wiggle = 10








            
